"use strict";

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("reshow-runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("reshow-runtime/helpers/objectWithoutProperties"));

var _defineProperty2 = _interopRequireDefault(require("reshow-runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _callFunc = _interopRequireDefault(require("call-func"));

var _getObjectValue = _interopRequireDefault(require("get-object-value"));

var _reactAtomicMolecule = require("react-atomic-molecule");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var isArray = Array.isArray;

var plusOne = function plusOne(i) {
  return i + 1;
};

var getFromTo = function getFromTo(from, to) {
  return plusOne(from) + '-' + plusOne(to);
};

var keys = Object.keys;

var mergeStyle = function mergeStyle(main) {
  var style = _objectSpread({}, (0, _getObjectValue["default"])(main, ['style'], {}));

  for (var _len = arguments.length, merges = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    merges[_key - 1] = arguments[_key];
  }

  merges.forEach(function (m) {
    var mStyle = (0, _getObjectValue["default"])(m, ['style'], {});
    keys(mStyle).forEach(function (key) {
      return style[key] = mStyle[key];
    });
  });
  return style;
};

var BasePage = function BasePage(props) {
  var onPageChange = props.onPageChange,
      component = props.component,
      className = props.className,
      children = props.children,
      style = props.style,
      url = props.url,
      rel = props.rel;
  var classes = (0, _reactAtomicMolecule.mixClass)((0, _getObjectValue["default"])(component, ['props', 'className']), className, 'item link');
  var onClick = onPageChange ? function () {
    return (0, _callFunc["default"])(onPageChange, [{
      begin: props[0],
      end: props[1],
      page: props['currentPage'],
      perPageNum: props['perPageNum']
    }]);
  } : null;
  return (0, _reactAtomicMolecule.build)(component)({
    rel: rel,
    title: getFromTo(props[0], props[1]),
    className: classes,
    href: url,
    style: style,
    onClick: onClick,
    'data-begin': props[0],
    'data-end': props[1],
    'data-page': props['currentPage'],
    'data-per-page-num': props['perPageNum']
  }, children);
};

var Page = function Page(props) {
  return _react["default"].createElement(BasePage, props, props.currentPage);
};

var Forward = function Forward(_ref) {
  var isLastPage = _ref.isLastPage,
      text = _ref.text,
      props = (0, _objectWithoutProperties2["default"])(_ref, ["isLastPage", "text"]);
  return _react["default"].createElement(BasePage, (0, _extends2["default"])({}, props, {
    rel: "next"
  }), isLastPage ? props.currentPage : text);
};

var Backward = function Backward(_ref2) {
  var text = _ref2.text,
      props = (0, _objectWithoutProperties2["default"])(_ref2, ["text"]);
  return _react["default"].createElement(BasePage, (0, _extends2["default"])({}, props, {
    rel: "prev"
  }), props.currentPage === 1 ? props.currentPage : text);
};

var Current = function Current(props) {
  return _react["default"].createElement(_reactAtomicMolecule.Item, {
    style: props.style,
    title: getFromTo(props[0], props[1]),
    className: (0, _reactAtomicMolecule.mixClass)('active', props.className)
  }, props.currentPage);
};

var FirstPage = function FirstPage(props) {
  return _react["default"].createElement(Page, props);
};

var LastPage = function LastPage(props) {
  return _react["default"].createElement(Page, props);
};

var Ellipsis = function Ellipsis(props) {
  return _react["default"].createElement(_reactAtomicMolecule.Item, {
    className: "disabled ellipsis",
    style: _objectSpread({
      minWidth: 0,
      width: 0
    }, props.style)
  }, "...");
};

var Pagination = function Pagination(pg) {
  injects = (0, _reactAtomicMolecule.lazyInject)(injects, InjectStyles);
  var linkComponent = pg.linkComponent,
      onPageChange = pg.onPageChange,
      forwardText = pg.forwardText,
      backwardText = pg.backwardText,
      ui = pg.ui,
      currentPageProps = pg.currentPageProps;
  var firstPage;
  var firstEllipsis;
  var lastPage;
  var lastEllipsis;
  var pageProps = pg.pageProps || {};
  pageProps.onPageChange = onPageChange;
  pageProps.component = linkComponent;

  var ellipsisProps = _objectSpread({}, pageProps, {
    onPageChange: null
  });

  if (pg.firstPage) {
    firstPage = _react["default"].createElement(FirstPage, (0, _extends2["default"])({}, pg.firstPage, pageProps));
    firstEllipsis = _react["default"].createElement(Ellipsis, ellipsisProps);
  }

  if (pg.lastPage) {
    lastPage = _react["default"].createElement(LastPage, (0, _extends2["default"])({}, pg.lastPage, pageProps));
    lastEllipsis = _react["default"].createElement(Ellipsis, ellipsisProps);
  }

  var pgList = pg.list;

  if (!isArray(pgList)) {
    console.error('Page list not array', pg);
  }

  return _react["default"].createElement(_reactAtomicMolecule.Menu, {
    className: "compact pagination",
    ui: ui
  }, firstPage, firstEllipsis, pgList.map(function (v, k) {
    var current = pg.currentPage;

    if (v.currentPage) {
      if (current.backward && current.backward.currentPage === v.currentPage || current.forward && current.forward.currentPage === v.currentPage) {
        return null;
      }

      return _react["default"].createElement(Page, (0, _extends2["default"])({}, pageProps, {
        key: k
      }, v));
    } else {
      var re = [];

      if (current.backward) {
        re.push(_react["default"].createElement(Backward, (0, _extends2["default"])({
          text: backwardText
        }, current.backward, pageProps)));
      }

      re.push(_react["default"].createElement(Current, (0, _extends2["default"])({
        key: k
      }, pageProps, current, currentPageProps, {
        style: mergeStyle(pageProps, currentPageProps)
      })));

      if (current.forward) {
        re.push(_react["default"].createElement(Forward, (0, _extends2["default"])({
          isLastPage: pgList.length - 2 === k
        }, current.forward, {
          text: forwardText
        }, pageProps)));
      }

      return re;
    }
  }), lastEllipsis, lastPage);
};

Pagination.defaultProps = {
  linkComponent: 'a',
  forwardText: '> Next',
  backwardText: '<'
};
var _default = Pagination;
exports["default"] = _default;
var injects;
var pgCssSelector = '.pagination.ui.menu:not(.vertical) .item';
var InjectStyles = {
  hidePg: [{
    display: 'none',
    minWidth: '2rem',
    justifyContent: 'center'
  }, pgCssSelector],
  showPg: [{
    display: 'flex'
  }, [_reactAtomicMolecule.min.sm, pgCssSelector]]
};
module.exports = exports.default;